import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
import React, { useEffect } from 'react';
var PercentChart = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    var _j = React.useState(0), percent = _j[0], setPercent = _j[1];
    var getColorByPercent = function (percent) {
        if (percent <= 20)
            return '#ff4d4f';
        if (percent <= 40)
            return '#ffa940';
        if (percent <= 60)
            return '#fadb14';
        if (percent <= 80)
            return '#73d13d';
        return '#52c41a';
    };
    var fontSizeSetup = (_d = (_c = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.font_size;
    var styleText = {
        width: '100%',
        textAlign: 'center',
        fontSize: fontSizeSetup ? "".concat(fontSizeSetup, "px") : '30px',
        color: ((_h = (_g = (_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.item_styles) === null || _f === void 0 ? void 0 : _f[0]) === null || _g === void 0 ? void 0 : _g.style) === null || _h === void 0 ? void 0 : _h.color) || getColorByPercent(percent) || '#67C23A',
        fontWeight: 'bold',
    };
    useEffect(function () {
        var _a, _b;
        if (props.chartData && Array.isArray(props.chartData) && props.chartData.length > 0) {
            var value = props.chartData[0][(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field];
            setPercent(Number(value));
        }
    }, [props.setup.chart, props.chartData]);
    return (_jsxs("div", { className: "percentChart", style: {
            width: '100%',
        }, children: [_jsxs("div", { className: "percentChart__text", style: styleText, children: [percent.toFixed(1), "%"] }), _jsx("div", { className: "percentChart__bar", style: {
                    width: '100%',
                    height: '25px',
                    backgroundColor: '#f0f0f0',
                    borderRadius: '5px',
                    overflow: 'hidden',
                    marginBottom: '10px',
                }, children: _jsx("div", { className: "percentChart__percent", style: {
                        width: "".concat(percent, "%"),
                        height: '100%',
                        backgroundColor: getColorByPercent(percent),
                        transition: 'all 0.3s ease-in-out',
                    } }) })] }));
};
export default PercentChart;
